<template>
    <div class="content__leftAnalitika">
        <div class="box__analitika">
            <div class="analitika__top--top ">
                <div class="top-top--left animated fadeInLeft">
                    <p class="top-bold">{{ $t('analytics.profit.title') }}</p>
                    <p class="top-text">{{ $t('analytics.profit.description') }}</p>
                    <p class="date-text">{{ $t('analytics.profit.today_date') }}<span>{{ today_date }}</span> </p>
                    <p class="text-priceBlue">{{ currencies.formatInDefault(stats.profit) }}</p>
                </div>
                <div class="top-top--right animated fadeInRight">
                    <p class="top-bold">{{ $t('analytics.cash_flow.title') }}</p>
                    <p class="top-text"><span>*</span>{{ $t('analytics.cash_flow.hint') }}</p>
                    <div class="box-right--flex">
                        <div class="box__flex--elementRight">
                            <svg class="greyCoin">
                                <use xlink:href="/img/sprite.svg#coin"></use>
                            </svg>
                            <p class="text-podCoin">{{ $t('analytics.cash_flow.estimated_tomorrow') }}</p>
                            <p class="text-bold">{{ currencies.formatInDefault(stats.estimated_tomorrow) }}</p>
                        </div>
                        <div class="box__flex--elementRight">
                            <svg class="greyCoin">
                                <use xlink:href="/img/sprite.svg#coin"></use>
                            </svg>
                            <p class="text-podCoin">{{ $t('analytics.cash_flow.estimated_week') }}</p>
                            <p class="text-bold">{{ currencies.formatInDefault(stats.estimated_week) }}</p>
                        </div>
                        <div class="box__flex--elementRight">
                            <svg class="redCoin">
                                <use xlink:href="/img/sprite.svg#coin"></use>
                            </svg>
                            <p class="text-podCoin">{{ $t('analytics.cash_flow.estimated_month') }}</p>
                            <p class="text-bold">{{ currencies.formatInDefault(stats.estimated_month) }}</p>
                        </div>
                        <div class="box__flex--elementRight">
                            <svg class="blueCoin">
                                <use xlink:href="/img/sprite.svg#coin"></use>
                            </svg>
                            <p class="text-podCoin">{{ $t('analytics.cash_flow.estimated_half_year') }}</p>
                            <p class="text-bold">{{ currencies.formatInDefault(stats.estimated_half_year) }}</p>
                        </div>
                    </div>
                </div>
            </div>
            <div class="analitika__top wow fadeInUp">
                <h2 class="title-analitika">{{ $t('analytics.form.title') }}</h2>
                <form action="#" @submit="submit">
                    <div class="box__ot--flex">
                        <date-block :label="$t('analytics.form.date_from')" :date="filter.from_date" :max-date="filter.to_date" @change="filter.from_date = $event"/>
                        <date-block :label="$t('analytics.form.date_to')" :date="filter.to_date" :min-date="filter.from_date" @change="filter.to_date = $event"/>
                    </div>
                    <div class="box__search">
                        <p class="text-search"><span>*</span>{{ $t('analytics.form.notice') }}</p>
                        <button type="button" @click="submit">
                            {{ $t('analytics.form.submit') }}
                            <svg class="leftIcon">
                                <use xlink:href="/img/sprite.svg#magnifying-glass"></use>
                            </svg>
                        </button>
                    </div>
                </form>
            </div>
            <quick-filter @update="setQuick"/>
            <div class="block-one" v-if="analytics">
                <analytics-charts :analytics="analytics" :options="options"/>
                <div class="statis">
                    <div class="statis__left">
                        <p class="statis-title">{{ $t('analytics.stats.user_stats') }}</p>
                        <div class="left__element">
                            <svg>
                                <use xlink:href="/img/sprite.svg#usera"></use>
                            </svg>
                            <div class="element__right">
                                <p class="text-right">{{ $t('analytics.stats.users') }}</p>
                                <p class="text-big">{{ analytics.users_count }}</p>
                            </div>
                        </div>
                        <div class="left__element left__element--active">
                            <svg>
                                <use xlink:href="/img/sprite.svg#usera"></use>
                            </svg>
                            <div class="element__right">
                                <p class="text-right">{{ $t('analytics.stats.active_users') }}</p>
                                <p class="text-big">{{ analytics.active_users_count }}</p>
                            </div>
                        </div>
                    </div>
                    <div class="statis__right">
                        <div class="box-paginetion">
                            <a href="#" class="link-paginetion" :class="tabClass('first')" @click.prevent="setTab('first')" />
                            <a href="#" class="link-paginetion" :class="tabClass('second')" @click.prevent="setTab('second')" />
                            <a href="#" class="link-paginetion" :class="tabClass('third')" @click.prevent="setTab('third')" />
                        </div>
                        <div id="oneBar" class="bar-threeBlock" v-if="tab === 'first'">
                            <div class="box-oneFlex">
                                <div class="right__element">
                                    <active-users-chart class="users-percent-chart" :active="analytics.active_users_count" :total="analytics.users_count"/>
                                    <div class="right__element--right">
                                        <p class="text-title">{{ $t('analytics.stats.active_percent') }}</p>
                                        <p class="text-podrobno">{{ $t('analytics.stats.active_percent_help') }}</p>
                                    </div>
                                </div>
                                <div class="right__element">
                                    <users-growth class="users-percent-chart" :users_count="analytics.users_count" :previous_users_count="analytics.previous_users_count"/>
                                    <div class="right__element--right">
                                        <p class="text-title">{{ $t('analytics.stats.users_growth') }}</p>
                                        <p class="text-podrobno">{{ $t('analytics.stats.users_growth_help') }}</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="bar-threeBlock" v-else-if="tab === 'second'">
                            <div class="box-twoFlex">
                                <div class="box-twoElement">
                                    <p class="title-text">{{ $t('analytics.stats.average_deposit') }}</p>
                                    <p class="text-podTitle">{{ $t('analytics.stats.average_deposit_help') }}</p>
                                </div>
                                <div class="box-twoElementWidth">
                                    <average-deposit-chart :deposits="analytics.average_deposit"/>
                                </div>
                            </div>
                        </div>

                        <div id="threeBar" class="bar-threeBlock box-threeFlex" v-else-if="tab === 'third'">
                            <div class="top-text">
                                <p class="text-top">{{ $t('analytics.stats.new_users') }}</p>
                                <p class="text-topNoBold"></p>
                            </div>
                            <div class="box-flexGraphick">
                                <users-registrations-chart :users="analytics.users_registered"/>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="block-none wow fadeInRightBig" v-else>
                <div class="box-img"><img src="/img/pie-chart111.png" alt=""></div>
                <p class="text-podBox-img">{{ $t('analytics.stats.none_enter') }} <a href="">{{ $t('analytics.stats.none_enter_link') }}</a></p>
                <p class="text-podskazka">{{ $t('analytics.stats.none_help') }}</p>
            </div>
        </div>
    </div>
</template>

<script>
    import {mapGetters} from "vuex";
    import currencies from "../currencies";
    import QuickFilter from "../components/analytics/QuickFilter";
    import DateBlock from "../components/analytics/DateBlock";
    import AnalyticsCharts from "../components/analytics/AnalyticsCharts";
    import AverageDepositChart from "../components/analytics/AverageDepositChart";
    import UsersRegistrationsChart from "../components/analytics/UsersRegistrationsChart";
    import UsersGrowth from "../components/analytics/UsersGrowth";
    import ActiveUsersChart from "../components/analytics/ActiveUsersChart";

	export default {
		name: "ProjectAnalytics",
        data(){
		    return {
		        filter: {
		            from_date: '2020-03-24T04:32:05.156Z',
		            to_date: '2020-03-24T04:32:05.156Z',
                },
                time: '',
                tab: 'first',
                stats: {},
                options: {
		            grid: {
                        left: 0,
                        top: 10,
                        width: '98%',
                    }
                },
                analytics: null
            };
        },
        computed: {
            ...mapGetters([
                'axios'
            ]),
            currencies: () => currencies,
            today_date(){
                return this.$date().format('DD.MM.YYYY');
            },
        },
        methods: {
		    loadStats(){
                this.axios
                    .get('analytics/stats')
                    .then(resp => resp.data)
                    .then(stats => {
                        this.stats = stats;
                    })
            },
            submit(){
                this.axios
                    .post('analytics', {
                        from: this.$date(this.filter.from_date).format('YYYY-MM-DD HH:mm:ss'),
                        to: this.$date(this.filter.to_date).format('YYYY-MM-DD HH:mm:ss'),
                    })
                    .then(resp => resp.data)
                    .then(analytics => {
                        this.analytics = analytics;
                    })
            },
            setFormatter(startDate, endDate){/*
                const start = this.$date(startDate);
                const end = this.$date(endDate);
                if(end.diff(start, "year") > 3){
                    this.options = Object.assign({}, this.options, {
                        xAxis: {
                            axisLabel: {
                                formatter: (value) => {
                                    return this.$date(value).format('YYYY');
                                }
                            }
                        }
                    });
                }else if(end.diff(start, "month") > 3){
                    this.options = Object.assign({}, this.options, {
                        xAxis: {
                            axisLabel: {
                                formatter: (value) => {
                                    return this.$date(value).format('MM');
                                }
                            }
                        }
                    });
                }else if(end.diff(start, "day") > 3){
                    this.options = Object.assign({}, this.options, {
                        xAxis: {
                            axisLabel: {
                                formatter: (value) => {
                                    return this.$date(value).format('DD.MM');
                                }
                            }
                        }
                    });
                }else{
                    this.options = Object.assign({}, this.options, {
                        xAxis: {
                            axisLabel: {
                                formatter: (value) => {
                                    return this.$date(value).format('HH:mm');
                                }
                            }
                        }
                    });
                }*/
            },
            setQuick(obj){
		        this.filter.from_date = obj.start;
		        this.filter.to_date = obj.end;
		        this.setFormatter(obj.start, obj.end)
		        this.submit();
            },
            tabClass(tab){
		        return {
		            'link-paginetion-active' : tab === this.tab
                };
            },
            setTab(tab){
		        this.tab = tab;
            }
        },
        components: {
            DateBlock,
            QuickFilter,
            AnalyticsCharts,
            ActiveUsersChart,
            UsersGrowth,
            AverageDepositChart,
            UsersRegistrationsChart
        },
        mounted() {
		    this.loadStats();
        }
    }
</script>

<style scoped>
</style>
